﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
Sub Class_Globals

	Dim NumPages As Int = 2
	Dim NavDrawer As AHNavigationDrawer
	Dim pContent As Panel
	Dim sd As SlideDrawable
	Dim ivDrawer As ImageView
	Dim LV1 As mListView
	Dim btHome As Button
	Dim Pages(NumPages) As Panel
	
	' Maybe this isn't the correct place for this - it might need to go into the Main Activity
	Dim CurrentPage As String = "Activity 1"
	
End Sub

Public Sub Initialize(act As Activity, vColor As Int, startX As Float, startY As Float)

	Log("ClassMenu.Initialize(): started")
	
	act.LoadLayout("l1")
	
	Log("ClassMenu.Initialize(): Initialize the navigation drawer.")
	NavDrawer.Initialize("Drawer" ,  pContent,  300dip)

	Log("ClassMenu.Initialize(): Makes the edge bigger so it is much easier to open")
	NavDrawer.SetEdgeSize(NavDrawer.GRAVITY_START, NavDrawer.GetEdgeSize(NavDrawer.GRAVITY_START) * 13)
	Log("ClassMenu.Initialize(): 1")
	
	' I get an error in line 2 below: "NoSuchFieldException: drawer_shadow"
	' Let's forget about the shadow for the time being! Hopefully this isn't the reason for the Views showing through the menu!
	'''''' NavDrawer.ShadowDrawable = GetNPDrawable("drawer_shadow")
	
	Log("Create the drawer indicator - 3 small horizontal bars in top-left corner of screen")
	Dim bd As BitmapDrawable
	bd.Initialize(LoadBitmap(File.DirAssets, "ic_drawer.png"))
	sd.Initialize(bd)
	ivDrawer.Background = sd
	
	Log("Create the navigation listview")
	'We use the mListView library from icefairy333 in this example because it has a selected item feature.
	'http://www.basic4ppc.com/forum/additional-libraries-classes-official-updates/25413-lib-mListView-based-native-ListView.html
	LV1.Initialize("LV1")
	
	Log("Set up the divider")
	Dim cdDivider As ColorDrawable
	cdDivider.Initialize(Colors.Black, 0)
	LV1.SingleLineLayout.Label.TextColor=Colors.Black ' text colour for the menu items - needs to be black for all but selected row.
	LV1.Divider = cdDivider
	LV1.DividerHeight = 1dip
	
	LV1.TwoLinesAndBitmap.Label.TextColor=Colors.Black	' text colour for the menu items - needs to be black for all but selected row.
	Dim cdSelectedMenu As ColorDrawable
	cdSelectedMenu.Initialize(Colors.Green, 0)
	LV1.SingleLineLayout.SelectedBackground = cdSelectedMenu
	LV1.SetData
	
	Log("Add colours for different items")
	Dim cdHomeButton As ColorDrawable
	cdHomeButton.Initialize(Colors.Green,   0)
	btHome.Background = cdHomeButton

		Log("Create some Panels we show as 'Pages'")
	'In normal Java projects you would use fragments for a page. Since we have no fragments support in B4A we just have to use panels.
	For I = 0 To NumPages - 1
		Log("Activity_Create: I=" & I)
		Dim strPageName As String
		Pages(I).Initialize("")
		Pages(I).Visible = False
		
		Select I
			Case 0
				strPageName = "Activity 1"
			Case 1
				strPageName = "Activity 2"
		End Select
		
		Pages(I).Tag = strPageName
		
		LV1.AddSingleLine(strPageName)
		
		NavDrawer.ContentPanel.AddView(Pages(I), (pContent.Width - Min(pContent.Width, pContent.Height)) / 2,  (pContent.Height - Min(pContent.Width, pContent.Height)) / 2 , Min(pContent.Width, pContent.Height), Min(pContent.Width, pContent.Height))
	Next

	Log("We add the mListView to our NavigationPanel")
	NavDrawer.NavigationPanel.AddView(LV1, 0 , 0, pContent.width, pContent.height)
	NavDrawer.NavigationPanel.Color = Colors.White

	'Show the first page
	ShowPage(CurrentPage)
	
	Log("ClassMenu.Initialize(): ended")

End Sub

'Called when the drawer closes
Sub Drawer_DrawerClosed (DrawerGravity As Int)
	Log("Drawer Closed: " & DrawerGravity)
	btHome.Text = LV1.GetItem(LV1.GetSelection)
End Sub

'Called when the drawer opens
Sub Drawer_DrawerOpened (DrawerGravity As Int)
	Log("Drawer Opened: " & DrawerGravity)
	btHome.Text = "Select Function"
End Sub

'Called while sliding the drawer
'Set the Offset of the Drawer indicator image
Sub Drawer_DrawerSlide (Position As Float, DrawerGravity As Int)
	sd.Offset = Position
End Sub

'Closes or opens the drawer
Sub btHome_Click
	If NavDrawer.IsDrawerOpen Then
		NavDrawer.CloseDrawer
	Else
		NavDrawer.OpenDrawer
	End If
End Sub

'Helper function to get the drawable for the shadow for the navigation panel.
Sub GetNPDrawable(Name As String) As Object

    Dim r As Reflector
    Dim package As String
    Dim id As Int
	Log("ClassMenu.GetNPDrawable(): 2")
    package = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
    id = r.GetStaticField(package & ".R$drawable", Name)
    r.Target = r.GetContext
    r.Target = r.RunMethod("getResources")
    Return r.RunMethod2("getDrawable", id, "java.lang.int")
	
End Sub

'Show a panel with the image of a planet
Sub ShowPage(Name As String)

	For i = 0 To NumPages - 1
		If Pages(i).Tag = Name Then
			Pages(i).Visible = True
			Pages(i).BringToFront
			LV1.SetSelection(i)
			CurrentPage = Name
			Log("ShowPage: Name=" & Name)
			btHome.Text = CurrentPage
		Else
			Pages(i).Visible = False
		End If
	Next
	
End Sub

'When an item is clicked in the list show the page of the correct planet and close the drawer
Sub LV1_ItemClick (Position As Int, Value As Object)

	Log("ClassMenu.LV1_ItemClick(): 1")

	ShowPage(Value)
	NavDrawer.CloseDrawer

	Log("LV1_ItemClick(): Value=" & Value & ", Position=" & Position)
	
	' Load the activity (Page) selected
	Select Position
		Case 0
			' Start the StatusPage Activity
			Log("LV1_ItemClick(): About to Activity.LoadLayout('StatusPage')")
			'Activity.LoadLayout("StatusPage")
			StartActivity(Main)
			Log("LV1_ItemClick(): Done Activity.LoadLayout('StatusPage')")
		Case 1
			'Activity.LoadLayout("DailyReportSmall")
			StartActivity(Activity2)
		Case Else
			Log("LV1_ItemClick(): No code for this page yet!")
			' do nothing for the time being until it is written! Actually do a Toast message
	End Select
	
End Sub